with Philosophers; use Philosophers;

procedure Main is
   --  the set of congregated dining philosophers
   Dining_Philosophers : array (Position_T) of Philosopher_Ref;
   --  the respective voluntary suspension intervals (in milliseconds)
   Wait_Times          : array (Position_T) of Positive :=
                           (500, 1_000, 1_500, 2_000, 2_500);
   --  and the respective reflection intervals (in milliseconds)
   Think_Loads         : array (Position_T) of Positive :=
                           (100, 200, 300, 400, 500);
begin
   --  we first create all instances of all philosophers
   for P in Position_T loop
      Dining_Philosophers (P) := new Philosopher_T
        (My_Position => P,
         Think_Load => Think_Loads (P),
         Some_Time => Wait_Times (P));
   end loop;
   --  and then let them do their job without interfering
   loop
      null;
   end loop;
end Main;
